# remirepo/Fedora spec file for php-zendframework-zend-hydrator
#
# Copyright (c) 2016-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    70b02f4d8676e64af932625751750b5ca72fff3a
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-hydrator
%global php_home     %{_datadir}/php
%global library      Hydrator
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.4.1
Release:        1%{?dist}
Summary:        Zend Framework %{library} component

License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-date
BuildRequires:  php-reflection
BuildRequires:  php-spl
# From composer, "require-dev": {
#        "phpunit/phpunit": "^5.7.27 || ^6.5.8 || ^7.1.2",
#        "zendframework/zend-coding-standard": "~1.0.0",
#        "zendframework/zend-eventmanager": "^2.6.2 || ^3.0",
#        "zendframework/zend-filter": "^2.6",
#        "zendframework/zend-inputfilter": "^2.6",
#        "zendframework/zend-serializer": "^2.6.1",
#        "zendframework/zend-servicemanager": "^2.7.5 || ^3.0.3"
BuildRequires: (php-autoloader(%{gh_owner}/zend-stdlib)         >= 3.0   with php-autoloader(%{gh_owner}/zend-stdlib)         < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-eventmanager)   >= 2.6.2 with php-autoloader(%{gh_owner}/zend-eventmanager)   < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-filter)         >= 2.6   with php-autoloader(%{gh_owner}/zend-filter)         < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-inputfilter)    >= 2.6   with php-autoloader(%{gh_owner}/zend-inputfilter)    < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-serializer)     >= 2.6.1 with php-autoloader(%{gh_owner}/zend-serializer)     < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-servicemanager) >= 2.7.5 with php-autoloader(%{gh_owner}/zend-servicemanager) < 4)
%global phpunit %{_bindir}/phpunit7
BuildRequires:  phpunit7 >= 7.1.4
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-stdlib": "^3.0"
Requires:       php(language) >= 5.6
Requires:      (php-autoloader(%{gh_owner}/zend-stdlib)         >= 3.0   with php-autoloader(%{gh_owner}/zend-stdlib)         < 4)
# From composer, "suggest": {
#        "zendframework/zend-eventmanager": "^2.6.2 || ^3.0, to support aggregate hydrator usage",
#        "zendframework/zend-filter": "^2.6, to support naming strategy hydrator usage"
#        "zendframework/zend-serializer": "^2.6.1, to use the SerializableStrategy",
#        "zendframework/zend-servicemanager": "^2.7.5 || ^3.0.3, to support hydrator plugin manager usage",
Suggests:       php-autoloader(%{gh_owner}/zend-eventmanager)   >= 2.6.2
Suggests:       php-autoloader(%{gh_owner}/zend-filter)         >= 2.6
Suggests:       php-autoloader(%{gh_owner}/zend-serializer)     >= 2.6.1
Suggests:       php-autoloader(%{gh_owner}/zend-servicemanager) >= 2.7.5
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 1.1.0
Requires:       php-date
Requires:       php-reflection
Requires:       php-spl
# Autoloader
Requires:       php-composer(%{gh_owner}/zend-loader)           >= 2.5

Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
Zend\Hydrator provides utilities for mapping arrays to objects,
and vice versa, including facilities for filtering which data
is mapped as well as providing mechanisms for mapping nested
structures.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Stdlib/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Zend/EventManager/autoload.php',
    '%{php_home}/Zend/Serializer/autoload.php',
    '%{php_home}/Zend/ServiceManager/autoload.php',
    '%{php_home}/Zend/Filter/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/InputFilter/autoload.php',
]);
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmdarg in "php %{phpunit}" "php70 %{_bindir}/phpunit6" php71 php72; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit7} -d memory_limit=1G || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}


%changelog
* Thu Nov 22 2018 Remi Collet <remi@remirepo.net> - 2.4.1-1
- update to 2.4.1

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.4.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Thu May  3 2018 Remi Collet <remi@remirepo.net> - 2.4.0-1
- update to 2.4.0
- use range dependencies
- switch to phpunit7

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.3.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Thu Dec  7 2017 Remi Collet <remi@remirepo.net> - 2.3.1-2
- switch from zend-loader to fedora/autoloader

* Tue Oct  3 2017 Remi Collet <remi@remirepo.net> - 2.3.1-1
- Update to 2.3.1

* Thu Sep 21 2017 Remi Collet <remi@remirepo.net> - 2.3.0-1
- Update to 2.3.0

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.2.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Mon May 22 2017 Remi Collet <remi@remirepo.net> - 2.2.2-1
- Update to 2.2.2
- raise dependency on PHP 5.6
- use phpunit6 on F26+

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.2.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Jun 29 2016 Remi Collet <remi@fedoraproject.org> - 2.2.1-1
- update to 2.2.1 for ZendFramework 3
- raise dependency on zend-stdlib >= 3.0

* Fri Feb 19 2016 Remi Collet <remi@fedoraproject.org> - 1.1.0-1
- update to 1.1.0
- raise dependency on zend-stdlib >= 2.7

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Jan 28 2016 Remi Collet <remi@fedoraproject.org> - 1.0.0-1
- initial package
